//+------------------------------------------------------------------+
//|                                                        Vidya.mq4 |
//|                                                                  |
//| Vidya developed by Tushar Chande                                 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property  indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  DimGray
#property  indicator_color3  DarkOrange
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_style2  STYLE_DOT

//
//
//
//
//

extern int  CmoPeriod      = 10;
extern int  SmoothPeriod   =  9;
extern bool ShowHighLine   = true;
extern bool ShowMiddleLine = true;
extern bool ShowLowLine    = true;

//
//
//
//
//

double vidya1[];
double vidya2[];
double vidya3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,vidya1);
   SetIndexBuffer(1,vidya2);
   SetIndexBuffer(2,vidya3);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
      if (ShowHighLine)   vidya1[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH  ,i),CmoPeriod,SmoothPeriod,0,i);
      if (ShowMiddleLine) vidya2[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i),CmoPeriod,SmoothPeriod,1,i);
      if (ShowLowLine)    vidya3[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW   ,i),CmoPeriod,SmoothPeriod,2,i);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  vidya.work[][6];
#define vidya.price 0
#define vidya.value 1

//
//
//
//
//

double iVidya(double price, int cmoPeriods, int smoothPeriods, int forCalculation, int i)
{
   if (ArrayRange(vidya.work,0)!=Bars) ArrayResize(vidya.work,Bars);
   
   int r = Bars-i-1;
   int s = forCalculation*2;
      double alpha = 2.00/(1.00+smoothPeriods);
   
      //
      //
      //
      //
      //
      
         vidya.work[r][s+vidya.price] = price;
         
               double sumUp  = 0;
               double sumDo  = 0;
               for (int j=0; j < cmoPeriods; j++)
               {
                  double diff = Close[i+j]-Close[i+j+1];
                  if (diff > 0)
                        sumUp += diff;
                  else  sumDo -= diff;
               }      
               double k = 1; if ((sumUp+sumDo)!=0) k = MathAbs((sumUp-sumDo)/(sumUp+sumDo));
      
          vidya.work[r][s+vidya.value] = k*alpha*vidya.work[r][s+vidya.price] + (1.0-(k*alpha))*vidya.work[r-1][s+vidya.value];
          
      //
      //
      //
      //
      //
                
   return(vidya.work[r][s+vidya.value]);
}